package com.hangum.vocabulary.dialog;

import org.apache.commons.lang.StringUtils;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Button;

import com.hangum.vocabulary.data.DataFileHandler;

/**
 * űԴܾ
 * 
 * < >  . ش  ܾ ѱ۴ܾ ´   
 * 				.      -,.-;;
 * 
 * @author hangum
 * @since 2007.12.10
 *
 */
public class NewWordsDialog extends Dialog {
	DataFileHandler dfh = null;  //  @jve:decl-index=0:
	String vocabulary[] = {"", ""};  //  @jve:decl-index=0:
	
	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private Label label = null;
	private Label label1 = null;
	private Text textEng = null;
	private Text textKor = null;
	private Button buttonConfirm = null;
	private Button buttonCancle = null;
	
	public NewWordsDialog(Shell shell) {
		this(shell, SWT.PRIMARY_MODAL);
	}
	
	public NewWordsDialog(Shell shell, int style) {
		super(shell, style);
	}
	
	public String[] open(DataFileHandler dfh) {
		this.dfh = dfh;
		createSShell();
		sShell.open();
		
		sShell.setMinimumSize(280, 126);
		sShell.pack();
		
		Display display = getParent().getDisplay();
		while (!sShell.isDisposed()) {
			if(!display.readAndDispatch()) {
				display.sleep();
			}
		}
		
		return vocabulary;
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData3 = new GridData();
		GridData gridData2 = new GridData();
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.horizontalSpan = 4;
		gridData1.verticalAlignment = GridData.CENTER;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalSpan = 4;
		gridData.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 5;
		sShell = new Shell(SWT.SHELL_TRIM | SWT.APPLICATION_MODAL);
		sShell.setText("New Words");
		sShell.setMaximized(false);
		sShell.setLocation(new Point(600, 400));
		sShell.setLayout(gridLayout);
		sShell.setSize(new Point(280, 126));
		label = new Label(sShell, SWT.NONE);
		label.setText("  ");
		label.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		textEng = new Text(sShell, SWT.BORDER);
		textEng.setLayoutData(gridData);
		label1 = new Label(sShell, SWT.NONE);
		label1.setText("  ");
		label1.setFont(new Font(Display.getDefault(), "Segoe UI", 9, SWT.BOLD));
		textKor = new Text(sShell, SWT.BORDER);
		textKor.setLayoutData(gridData1);
		Label filler8 = new Label(sShell, SWT.NONE);
		Label filler = new Label(sShell, SWT.NONE);
		Label filler6 = new Label(sShell, SWT.NONE);
		buttonConfirm = new Button(sShell, SWT.NONE);
		buttonConfirm.setText("(&s)");
		buttonConfirm.setLayoutData(gridData2);
		buttonConfirm
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						String txtEng = textEng.getText().trim();
						String txtKor = textKor.getText().trim();
						
						if("".equals(txtEng)) {
							MessageDialog.openError(null, "", " ܾ .");
							textEng.setFocus();
							return;
						}
						
						if("".equals(txtKor)) {
							MessageDialog.openError(null, "", "ѱ ܾ .");
							textKor.setFocus();							
							return;
						}
						
						//  ó
						String[] wordList = dfh.getWordList();
						for(int i = 0; i<wordList.length; i++) {
							String[] dataUnit = StringUtils.split(wordList[i], "|");
							
							if(txtEng.equals(dataUnit[0])) {
								MessageDialog.openError(null, "", " ܾ ̹ ϵǾ ֽϴ.");
								
								return;
							}
						}
						
						// ܾ Ѵ.
						dfh.setNewWords(txtEng, txtKor);
						MessageDialog.openConfirm(null, "Ȯ", "ܾ  Ǿϴ.");
						
						// Ѱ ޱ 
						vocabulary[0] = txtEng;
						vocabulary[1] = txtKor;
						
						sShell.close();
					}
				});
		buttonCancle = new Button(sShell, SWT.NONE);
		buttonCancle.setText("(&c)");
		buttonCancle.setLayoutData(gridData3);
		buttonCancle
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						sShell.close();
					}
				});
	}

}
